

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Absolute axes &mdash; libinput 1.12.1 documentation</title>
  

  
  
  
  

  

  
  
    

  

  
    <link rel="stylesheet" href="_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Coordinate ranges for absolute axes" href="absolute-coordinate-ranges.html" />
    <link rel="prev" title="Information for developers" href="development.html" /> 

  
  <script src="_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="index.html" class="icon icon-home"> libinput
          

          
          </a>

          
            
            
              <div class="version">
                1.12.1
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <ul class="current">
<li class="toctree-l1"><a class="reference internal" href="what-is-libinput.html">What is libinput?</a><ul>
<li class="toctree-l2"><a class="reference internal" href="what-is-libinput.html#what-libinput-is">What libinput is</a></li>
<li class="toctree-l2"><a class="reference internal" href="what-is-libinput.html#what-libinput-is-not">What libinput is not</a></li>
<li class="toctree-l2"><a class="reference internal" href="what-is-libinput.html#libinput-and-wayland">libinput and Wayland</a></li>
<li class="toctree-l2"><a class="reference internal" href="what-is-libinput.html#libinput-and-x-org">libinput and X.Org</a></li>
<li class="toctree-l2"><a class="reference internal" href="what-is-libinput.html#device-types">Device types</a><ul>
<li class="toctree-l3"><a class="reference internal" href="what-is-libinput.html#handled-device-types">Handled device types</a></li>
<li class="toctree-l3"><a class="reference internal" href="what-is-libinput.html#unhandled-device-types">Unhandled device types</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="features.html">libinput Features</a><ul>
<li class="toctree-l2"><a class="reference internal" href="button-debouncing.html">Button debouncing</a></li>
<li class="toctree-l2"><a class="reference internal" href="clickpad-softbuttons.html">Clickpad software button behavior</a><ul>
<li class="toctree-l3"><a class="reference internal" href="clickpad-softbuttons.html#software-button-areas">Software button areas</a></li>
<li class="toctree-l3"><a class="reference internal" href="clickpad-softbuttons.html#clickfinger-behavior">Clickfinger behavior</a></li>
<li class="toctree-l3"><a class="reference internal" href="clickpad-softbuttons.html#special-clickpads">Special Clickpads</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="gestures.html">Gestures</a><ul>
<li class="toctree-l3"><a class="reference internal" href="gestures.html#lifetime-of-a-gesture">Lifetime of a gesture</a></li>
<li class="toctree-l3"><a class="reference internal" href="gestures.html#pinch-gestures">Pinch gestures</a></li>
<li class="toctree-l3"><a class="reference internal" href="gestures.html#swipe-gestures">Swipe gestures</a></li>
<li class="toctree-l3"><a class="reference internal" href="gestures.html#touchscreen-gestures">Touchscreen gestures</a></li>
<li class="toctree-l3"><a class="reference internal" href="gestures.html#gestures-with-enabled-software-buttons">Gestures with enabled software buttons</a></li>
<li class="toctree-l3"><a class="reference internal" href="gestures.html#gestures-on-two-finger-touchpads">Gestures on two-finger touchpads</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="middle-button-emulation.html">Middle button emulation</a></li>
<li class="toctree-l2"><a class="reference internal" href="palm-detection.html">Palm detection</a><ul>
<li class="toctree-l3"><a class="reference internal" href="palm-detection.html#palm-detection-based-on-firmware-labelling">Palm detection based on firmware labelling</a></li>
<li class="toctree-l3"><a class="reference internal" href="palm-detection.html#palm-detection-based-on-pressure">Palm detection based on pressure</a></li>
<li class="toctree-l3"><a class="reference internal" href="palm-detection.html#palm-detection-based-on-touch-size">Palm detection based on touch size</a></li>
<li class="toctree-l3"><a class="reference internal" href="palm-detection.html#palm-exclusion-zones">Palm exclusion zones</a></li>
<li class="toctree-l3"><a class="reference internal" href="palm-detection.html#palm-detection-during-trackpoint-use">Palm detection during trackpoint use</a></li>
<li class="toctree-l3"><a class="reference internal" href="palm-detection.html#disable-while-typing">Disable-while-typing</a></li>
<li class="toctree-l3"><a class="reference internal" href="palm-detection.html#stylus-touch-arbitration">Stylus-touch arbitration</a></li>
<li class="toctree-l3"><a class="reference internal" href="palm-detection.html#thumb-detection">Thumb detection</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="scrolling.html">Scrolling</a><ul>
<li class="toctree-l3"><a class="reference internal" href="scrolling.html#horizontal-scrolling">Horizontal scrolling</a></li>
<li class="toctree-l3"><a class="reference internal" href="scrolling.html#two-finger-scrolling">Two-finger scrolling</a></li>
<li class="toctree-l3"><a class="reference internal" href="scrolling.html#edge-scrolling">Edge scrolling</a></li>
<li class="toctree-l3"><a class="reference internal" href="scrolling.html#on-button-scrolling">On-Button scrolling</a></li>
<li class="toctree-l3"><a class="reference internal" href="scrolling.html#scroll-sources">Scroll sources</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="t440-support.html">Lenovo *40 series touchpad support</a><ul>
<li class="toctree-l3"><a class="reference internal" href="t440-support.html#overview">Overview</a></li>
<li class="toctree-l3"><a class="reference internal" href="t440-support.html#size-of-the-buttons">Size of the buttons</a></li>
<li class="toctree-l3"><a class="reference internal" href="t440-support.html#button-behavior">Button behavior</a></li>
<li class="toctree-l3"><a class="reference internal" href="t440-support.html#kernel-support">Kernel support</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="tapping.html">Tap-to-click behaviour</a><ul>
<li class="toctree-l3"><a class="reference internal" href="tapping.html#tap-to-click-default-setting">Tap-to-click default setting</a></li>
<li class="toctree-l3"><a class="reference internal" href="tapping.html#tap-and-drag">Tap-and-drag</a></li>
<li class="toctree-l3"><a class="reference internal" href="tapping.html#constraints-while-tapping">Constraints while tapping</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="tablet-support.html">Tablet support</a><ul>
<li class="toctree-l3"><a class="reference internal" href="tablet-support.html#pad-buttons-vs-tablet-tools">Pad buttons vs. tablet tools</a></li>
<li class="toctree-l3"><a class="reference internal" href="tablet-support.html#tool-tip-events-vs-tool-button-events">Tool tip events vs. tool button events</a></li>
<li class="toctree-l3"><a class="reference internal" href="tablet-support.html#relative-motion-for-tablet-tools">Relative motion for tablet tools</a></li>
<li class="toctree-l3"><a class="reference internal" href="tablet-support.html#special-axes-on-tablet-tools">Special axes on tablet tools</a></li>
<li class="toctree-l3"><a class="reference internal" href="tablet-support.html#handling-of-proximity-events">Handling of proximity events</a></li>
<li class="toctree-l3"><a class="reference internal" href="tablet-support.html#pressure-offset-on-worn-out-tools">Pressure offset on worn-out tools</a></li>
<li class="toctree-l3"><a class="reference internal" href="tablet-support.html#tracking-unique-tools">Tracking unique tools</a></li>
<li class="toctree-l3"><a class="reference internal" href="tablet-support.html#vendor-specific-tablet-tool-types">Vendor-specific tablet tool types</a></li>
<li class="toctree-l3"><a class="reference internal" href="tablet-support.html#out-of-bounds-motion-events">Out-of-bounds motion events</a></li>
<li class="toctree-l3"><a class="reference internal" href="tablet-support.html#tablet-pad-button-numbers">Tablet pad button numbers</a></li>
<li class="toctree-l3"><a class="reference internal" href="tablet-support.html#tablets-in-left-handed-mode">Tablets in left-handed mode</a></li>
<li class="toctree-l3"><a class="reference internal" href="tablet-support.html#tablet-pad-modes">Tablet pad modes</a></li>
<li class="toctree-l3"><a class="reference internal" href="tablet-support.html#tablet-touch-arbitration">Tablet touch arbitration</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="switches.html">Switches</a><ul>
<li class="toctree-l3"><a class="reference internal" href="switches.html#lid-switch-handling">Lid switch handling</a></li>
<li class="toctree-l3"><a class="reference internal" href="switches.html#tablet-mode-switch-handling">Tablet mode switch handling</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="touchpad-pressure.html">Touchpad pressure-based touch detection</a><ul>
<li class="toctree-l3"><a class="reference internal" href="touchpad-pressure.html#information-provided-by-the-kernel">Information provided by the kernel</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="trackpoints.html">Trackpoints and Pointing Sticks</a><ul>
<li class="toctree-l3"><a class="reference internal" href="trackpoints.html#button-scrolling-on-trackpoints">Button scrolling on trackpoints</a></li>
<li class="toctree-l3"><a class="reference internal" href="trackpoints.html#motion-range-on-trackpoints">Motion range on trackpoints</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="configuration.html">Configuration options</a><ul>
<li class="toctree-l2"><a class="reference internal" href="configuration.html#tap-to-click">Tap-to-click</a></li>
<li class="toctree-l2"><a class="reference internal" href="configuration.html#send-events-mode">Send Events Mode</a></li>
<li class="toctree-l2"><a class="reference internal" href="configuration.html#pointer-acceleration">Pointer acceleration</a></li>
<li class="toctree-l2"><a class="reference internal" href="configuration.html#scrolling">Scrolling</a></li>
<li class="toctree-l2"><a class="reference internal" href="configuration.html#left-handed-mode">Left-handed Mode</a></li>
<li class="toctree-l2"><a class="reference internal" href="configuration.html#middle-button-emulation">Middle Button Emulation</a></li>
<li class="toctree-l2"><a class="reference internal" href="configuration.html#click-method">Click method</a></li>
<li class="toctree-l2"><a class="reference internal" href="configuration.html#disable-while-typing">Disable while typing</a></li>
<li class="toctree-l2"><a class="reference internal" href="configuration.html#calibration">Calibration</a></li>
<li class="toctree-l2"><a class="reference internal" href="configuration.html#rotation">Rotation</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="building.html">libinput build instructions</a><ul>
<li class="toctree-l2"><a class="reference internal" href="building.html#building">Building libinput</a><ul>
<li class="toctree-l3"><a class="reference internal" href="building.html#verifying-the-install">Verifying the install</a></li>
<li class="toctree-l3"><a class="reference internal" href="building.html#reverting-to-the-system-provided-libinput-package">Reverting to the system-provided libinput package</a></li>
<li class="toctree-l3"><a class="reference internal" href="building.html#selinux-adjustments">SELinux adjustments</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="building.html#build-dependencies">Build dependencies</a></li>
<li class="toctree-l2"><a class="reference internal" href="building.html#conditional-builds">Conditional builds</a></li>
<li class="toctree-l2"><a class="reference internal" href="building.html#building-against-libinput">Building against libinput</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="faqs.html">FAQs - Frequently Asked Questions</a><ul>
<li class="toctree-l2"><a class="reference internal" href="faqs.html#why-doesn-t-libinput-support">Why doesn’t libinput support …?</a></li>
<li class="toctree-l2"><a class="reference internal" href="faqs.html#my-mouse-moves-too-fast-even-at-the-slowest-setting">My mouse moves too fast, even at the slowest setting</a></li>
<li class="toctree-l2"><a class="reference internal" href="faqs.html#my-trackpoint-moves-too-slow-or-too-fast">My trackpoint moves too slow or too fast</a></li>
<li class="toctree-l2"><a class="reference internal" href="faqs.html#why-isn-t-touchpad-tap-to-click-enabled-by-default">Why isn’t touchpad tap-to-click enabled by default</a></li>
<li class="toctree-l2"><a class="reference internal" href="faqs.html#why-does-my-touchpad-lose-track-of-touches">Why does my touchpad lose track of touches</a></li>
<li class="toctree-l2"><a class="reference internal" href="faqs.html#kinetic-scrolling-does-not-work">Kinetic scrolling does not work</a></li>
<li class="toctree-l2"><a class="reference internal" href="faqs.html#is-libinput-gpl-licensed">Is libinput GPL-licensed?</a></li>
<li class="toctree-l2"><a class="reference internal" href="faqs.html#where-is-the-configuration-stored">Where is the configuration stored?</a></li>
<li class="toctree-l2"><a class="reference internal" href="faqs.html#how-do-i-configure-my-device-on-wayland">How do I configure my device on Wayland?</a></li>
<li class="toctree-l2"><a class="reference internal" href="faqs.html#how-do-i-configure-my-device-on-x">How do I configure my device on X?</a></li>
<li class="toctree-l2"><a class="reference internal" href="faqs.html#can-you-add-a-configuration-option-for-feature">Can you add a configuration option for $FEATURE?</a></li>
<li class="toctree-l2"><a class="reference internal" href="faqs.html#why-don-t-synclient-and-syndaemon-work-with-libinput">Why don’t synclient and syndaemon work with libinput?</a></li>
<li class="toctree-l2"><a class="reference internal" href="faqs.html#does-libinput-support-non-wacom-tablets">Does libinput support non-Wacom tablets?</a></li>
<li class="toctree-l2"><a class="reference internal" href="faqs.html#my-tablet-doesn-t-work">My tablet doesn’t work</a></li>
<li class="toctree-l2"><a class="reference internal" href="faqs.html#how-to-apply-hwdb-changes">How to apply hwdb changes</a></li>
<li class="toctree-l2"><a class="reference internal" href="faqs.html#what-causes-the-timer-offset-negative-warning">What causes the “timer offset negative” warning?</a></li>
<li class="toctree-l2"><a class="reference internal" href="faqs.html#is-libinput-required-for-wayland">Is libinput required for Wayland?</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="reporting-bugs.html">Reporting bugs</a><ul>
<li class="toctree-l2"><a class="reference internal" href="reporting-bugs.html#obtaining-the-libinput-version">Obtaining the libinput version</a></li>
<li class="toctree-l2"><a class="reference internal" href="reporting-bugs.html#reproducing-bugs">Reproducing bugs</a></li>
<li class="toctree-l2"><a class="reference internal" href="reporting-bugs.html#libinput-configuration-settings">libinput configuration settings</a></li>
<li class="toctree-l2"><a class="reference internal" href="reporting-bugs.html#reporting-touchpad-bugs">Reporting touchpad bugs</a></li>
<li class="toctree-l2"><a class="reference internal" href="reporting-bugs.html#reporting-mouse-bugs">Reporting mouse bugs</a></li>
<li class="toctree-l2"><a class="reference internal" href="reporting-bugs.html#reporting-keyboard-bugs">Reporting keyboard bugs</a></li>
<li class="toctree-l2"><a class="reference internal" href="reporting-bugs.html#reporting-trackpoint-bugs">Reporting trackpoint bugs</a></li>
<li class="toctree-l2"><a class="reference internal" href="reporting-bugs.html#all-other-devices">All other devices</a></li>
<li class="toctree-l2"><a class="reference internal" href="reporting-bugs.html#udev-information-for-the-device">udev information for the device</a></li>
<li class="toctree-l2"><a class="reference internal" href="reporting-bugs.html#recording-devices-with-evemu">Recording devices with evemu</a></li>
<li class="toctree-l2"><a class="reference internal" href="reporting-bugs.html#my-bug-was-closed-as-fixed-what-now">My bug was closed as fixed, what now?</a><ul>
<li class="toctree-l3"><a class="reference internal" href="reporting-bugs.html#when-is-it-ok-to-re-open-a-fixed-bug">When is it ok to re-open a fixed bug?</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="troubleshooting.html">Troubleshooting</a><ul>
<li class="toctree-l2"><a class="reference internal" href="tools.html">Helper tools</a><ul>
<li class="toctree-l3"><a class="reference internal" href="tools.html#libinput-list-devices">libinput list-devices</a></li>
<li class="toctree-l3"><a class="reference internal" href="tools.html#libinput-debug-events">libinput debug-events</a></li>
<li class="toctree-l3"><a class="reference internal" href="tools.html#libinput-debug-gui">libinput debug-gui</a></li>
<li class="toctree-l3"><a class="reference internal" href="tools.html#libinput-record-and-libinput-replay">libinput record and libinput replay</a></li>
<li class="toctree-l3"><a class="reference internal" href="tools.html#measuring-device-properties-with-libinput-measure">Measuring device properties with libinput measure</a></li>
<li class="toctree-l3"><a class="reference internal" href="tools.html#listing-quirks-assigned-to-a-device">Listing quirks assigned to a device</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="device-quirks.html">Device quirks</a><ul>
<li class="toctree-l3"><a class="reference internal" href="device-quirks.html#installing-temporary-local-device-quirks">Installing temporary local device quirks</a></li>
<li class="toctree-l3"><a class="reference internal" href="device-quirks.html#debugging-device-quirks">Debugging device quirks</a></li>
<li class="toctree-l3"><a class="reference internal" href="device-quirks.html#list-of-supported-device-quirks">List of supported device quirks</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="touchpad-jumping-cursors.html">Touchpad jumping cursor bugs</a></li>
<li class="toctree-l2"><a class="reference internal" href="touchpad-jitter.html">Touchpad jitter</a><ul>
<li class="toctree-l3"><a class="reference internal" href="touchpad-jitter.html#overriding-the-hysteresis-margins">Overriding the hysteresis margins</a></li>
<li class="toctree-l3"><a class="reference internal" href="touchpad-jitter.html#kernel-fuzz">Kernel fuzz</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="touchpad-pressure-debugging.html">Debugging touchpad pressure/size ranges</a><ul>
<li class="toctree-l3"><a class="reference internal" href="touchpad-pressure-debugging.html#debugging-touchpad-pressure-ranges">Debugging touchpad pressure ranges</a></li>
<li class="toctree-l3"><a class="reference internal" href="touchpad-pressure-debugging.html#debugging-touch-size-ranges">Debugging touch size ranges</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="trackpoint-configuration.html">Trackpoint configuration</a><ul>
<li class="toctree-l3"><a class="reference internal" href="trackpoint-configuration.html#the-magic-trackpoint-multiplier">The magic trackpoint multiplier</a></li>
<li class="toctree-l3"><a class="reference internal" href="trackpoint-configuration.html#measuring-the-trackpoint-range">Measuring the trackpoint range</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="tablet-debugging.html">Debugging tablet issues</a><ul>
<li class="toctree-l3"><a class="reference internal" href="tablet-debugging.html#required-tablet-capabilities">Required tablet capabilities</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l1 current"><a class="reference internal" href="development.html">Information for developers</a><ul class="current">
<li class="toctree-l2 current"><a class="reference internal" href="development.html#using-libinput-as-library">Using libinput as library</a><ul class="current">
<li class="toctree-l3 current"><a class="current reference internal" href="#">Absolute axes</a></li>
<li class="toctree-l3"><a class="reference internal" href="absolute-coordinate-ranges.html">Coordinate ranges for absolute axes</a></li>
<li class="toctree-l3"><a class="reference internal" href="normalization-of-relative-motion.html">Normalization of relative motion</a></li>
<li class="toctree-l3"><a class="reference internal" href="seats.html">Seats</a></li>
<li class="toctree-l3"><a class="reference internal" href="timestamps.html">Timestamps</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="development.html#hacking-on-libinput">Hacking on libinput</a><ul>
<li class="toctree-l3"><a class="reference internal" href="contributing.html">Contributing to libinput</a></li>
<li class="toctree-l3"><a class="reference internal" href="architecture.html">libinput’s internal architecture</a></li>
<li class="toctree-l3"><a class="reference internal" href="test-suite.html">libinput test suite</a></li>
<li class="toctree-l3"><a class="reference internal" href="pointer-acceleration.html">Pointer acceleration</a></li>
<li class="toctree-l3"><a class="reference internal" href="device-configuration-via-udev.html">Static device configuration via udev</a></li>
</ul>
</li>
</ul>
</li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="index.html">libinput</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="index.html">Docs</a> &raquo;</li>
        
          <li><a href="development.html">Information for developers</a> &raquo;</li>
        
      <li>Absolute axes</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
            
            <a href="_sources/absolute-axes.rst.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <blockquote>
<div></div></blockquote>
<div class="section" id="absolute-axes">
<span id="id1"></span><h1>Absolute axes<a class="headerlink" href="#absolute-axes" title="Permalink to this headline">¶</a></h1>
<p>Devices with absolute axes are those that send positioning data for an axis in
a device-specific coordinate range, defined by a minimum and a maximum value.
Compare this to relative devices (e.g. a mouse) that can only detect
directional data, not positional data.</p>
<p>libinput supports three types of devices with absolute axes:</p>
<blockquote>
<div><ul class="simple">
<li>multi-touch screens</li>
<li>single-touch screens</li>
<li><a class="reference internal" href="tablet-support.html#tablet-support"><span class="std std-ref">graphics tablets</span></a></li>
</ul>
</div></blockquote>
<p>Touchpads are technically absolute devices but libinput converts the axis values
to directional motion and posts events as relative events. Touchpads do not count
as absolute devices in libinput.</p>
<p>For all absolute devices in libinput, the default unit for x/y coordinates is
in mm off the top left corner on the device, or more specifically off the
device’s sensor. If the device is physically rotated from its natural
position and this rotation was communicated to libinput (e.g. by setting
the device left-handed),
the coordinate origin is the top left corner in the current rotation.</p>
<div class="section" id="handling-of-absolute-coordinates">
<span id="absolute-axes-handling"></span><h2>Handling of absolute coordinates<a class="headerlink" href="#handling-of-absolute-coordinates" title="Permalink to this headline">¶</a></h2>
<p>In most use-cases, absolute input devices are mapped to a single screen. For
direct input devices such as touchscreens the aspect ratio of the screen and
the device match. Mapping the input device position to the output position is
thus a simple mapping between two coordinates. libinput provides the API for
this with</p>
<ul class="simple">
<li><strong>libinput_event_pointer_get_absolute_x_transformed()</strong> for pointer events</li>
<li><strong>libinput_event_touch_get_x_transformed()</strong> for touch events</li>
</ul>
<p>libinput’s API only provides the call to map into a single coordinate range.
If the coordinate range has an offset, the compositor is responsible for
applying that offset after the mapping. For example, if the device is mapped
to the right of two outputs, add the output offset to the transformed
coordinate.</p>
</div>
<div class="section" id="devices-without-x-y-resolution">
<span id="absolute-axes-nores"></span><h2>Devices without x/y resolution<a class="headerlink" href="#devices-without-x-y-resolution" title="Permalink to this headline">¶</a></h2>
<p>An absolute device that does not provide a valid resolution is considered
buggy and must be fixed in the kernel. Some touchpad devices do not
provide resolution, those devices are correctly handled within libinput
(touchpads are not absolute devices, as mentioned above).</p>
</div>
<div class="section" id="calibration-of-absolute-devices">
<span id="calibration"></span><h2>Calibration of absolute devices<a class="headerlink" href="#calibration-of-absolute-devices" title="Permalink to this headline">¶</a></h2>
<p>Absolute devices may require calibration to map precisely into the output
range required. This is done by setting a transformation matrix, see
<strong>libinput_device_config_calibration_set_matrix()</strong> which is applied to
each input coordinate.</p>
<div class="math notranslate nohighlight">
\[\begin{split}\begin{pmatrix}
 cos\theta &amp; -sin\theta &amp; xoff \\
 sin\theta &amp;  cos\theta &amp; yoff \\
 0   &amp; 0    &amp; 1
\end{pmatrix} \begin{pmatrix}
x \\ y \\ 1
\end{pmatrix}\end{split}\]</div>
<p><span class="math notranslate nohighlight">\(\theta\)</span> is the rotation angle. The offsets <span class="math notranslate nohighlight">\(xoff\)</span> and <span class="math notranslate nohighlight">\(yoff\)</span> are
specified in device dimensions, i.e. a value of 1 equals one device width or
height. Note that rotation applies to the device’s origin, rotation usually
requires an offset to move the coordinates back into the original range.</p>
<p>The most common matrices are:</p>
<ul>
<li><dl class="first docutils">
<dt>90 degree clockwise:</dt>
<dd><div class="first last math notranslate nohighlight">
\[\begin{split}\begin{pmatrix}
 0 &amp; -1 &amp; 1 \\
 1 &amp; 0 &amp; 0 \\
 0 &amp; 0 &amp; 1
\end{pmatrix}\end{split}\]</div>
</dd>
</dl>
</li>
<li><dl class="first docutils">
<dt>180 degree clockwise:</dt>
<dd><div class="first last math notranslate nohighlight">
\[\begin{split}\begin{pmatrix}
 -1 &amp; 0 &amp; 1 \\
 0 &amp; -1 &amp; 1 \\
 0 &amp; 0 &amp; 1
\end{pmatrix}\end{split}\]</div>
</dd>
</dl>
</li>
<li><dl class="first docutils">
<dt>270 degree clockwise:</dt>
<dd><div class="first last math notranslate nohighlight">
\[\begin{split}\begin{pmatrix}
 0 &amp; 1 &amp; 0 \\
 -1 &amp; 0 &amp; 1 \\
 0 &amp; 0 &amp; 1
\end{pmatrix}\end{split}\]</div>
</dd>
</dl>
</li>
<li><dl class="first docutils">
<dt>reflection along y axis:</dt>
<dd><div class="first last math notranslate nohighlight">
\[\begin{split}\begin{pmatrix}
 -1 &amp; 0 &amp; 1 \\
 1 &amp; 0 &amp; 0 \\
 0 &amp; 0 &amp; 1
\end{pmatrix}\end{split}\]</div>
</dd>
</dl>
</li>
</ul>
<p>See Wikipedia’s
<a class="reference external" href="http://en.wikipedia.org/wiki/Transformation_matrix">Transformation Matrix article</a>
for more information on the matrix maths. See
<strong>libinput_device_config_calibration_get_default_matrix()</strong> for how these
matrices must be supplied to libinput.</p>
<p>Once applied, any x and y axis value has the calibration applied before it
is made available to the caller. libinput does not provide access to the
raw coordinates before the calibration is applied.</p>
</div>
<div class="section" id="why-x-y-coordinates-are-not-normalized">
<span id="absolute-axes-nonorm"></span><h2>Why x/y coordinates are not normalized<a class="headerlink" href="#why-x-y-coordinates-are-not-normalized" title="Permalink to this headline">¶</a></h2>
<p>x/y are not given in <a class="reference internal" href="normalization-of-relative-motion.html#motion-normalization"><span class="std std-ref">normalized coordinates</span></a>
([0..1]) for one simple reason: the aspect ratio of virtually all current
devices is something other than 1:1. A normalized axes thus is only useful to
determine that the stylus is e.g. at 78% from the left, 34% from the top of
the device. Without knowing the per-axis resolution, these numbers are
meaningless. Worse, calculation based on previous coordinates is simply wrong:
a movement from 0/0 to 50%/50% is not a 45-degree line.</p>
<p>This could be alleviated by providing resolution and information about the
aspect ratio to the caller. Which shifts processing and likely errors into the
caller for little benefit. Providing the x/y axes in mm from the outset
removes these errors.</p>
</div>
</div>


           </div>
           
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="absolute-coordinate-ranges.html" class="btn btn-neutral float-right" title="Coordinate ranges for absolute axes" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="development.html" class="btn btn-neutral" title="Information for developers" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2018, the libinput authors.

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'./',
            VERSION:'1.12.1',
            LANGUAGE:'None',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true,
            SOURCELINK_SUFFIX: '.txt'
        };
    </script>
      <script type="text/javascript" src="_static/jquery.js"></script>
      <script type="text/javascript" src="_static/underscore.js"></script>
      <script type="text/javascript" src="_static/doctools.js"></script>
      <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.1/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>

  

  
  
    <script type="text/javascript" src="_static/js/theme.js"></script>
  

  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>